#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf polipo-git20121118.tar.bz2
    cd polipo-git20121118
    make all CDEBUGFLAGS="$CFLAGS -Wall"
    strip -R .note -R .comment polipo
    mkdir -p ../polipo/bin ../polipo/share/polipo/www/doc
    cp polipo ../polipo/bin/
    cp html/* ../polipo/share/polipo/www/doc/
    sed -i -e 's@doc/@doc/index.html@' localindex.html
    cp localindex.html ../polipo/share/polipo/www/index.html
    touch ../polipo/etc/polipo/forbidden
    touch ../polipo/etc/polipo/uncachable
    cd ..
    rm -rf polipo-git20121118
}

chmod 0600 polipo/etc/polipo/config

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
